import os
import torch
import numpy as np


class Exp_Basic(object):
    def __init__(self, args):
        self.args = args
        mult_gpu = ',' in self.args.gpu 
        if not mult_gpu:
            self.device = f"cuda:{self.args.gpu}"#self._acquire_device()
            self.model = self._build_model().to(self.device)
        else:
            gpu_lst = [int(i) for i in self.args.gpu.split(",")]
            self.device = f"cuda:{gpu_lst[0]}"#self._acquire_device()
            self.model = self._build_model().to(self.device)
            self.model = torch.nn.DataParallel(self.model, gpu_lst)
    def _build_model(self):
        raise NotImplementedError
        return None

    def _get_data(self):
        pass

    def vali(self):
        pass

    def train(self):
        pass

    def test(self):
        pass
